unit vytah1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  StdCtrls, Menus, StrUtils;

const
  LineTerm = #13#10;   // konec radky
  TimeOut = 10;        // time out

type
  TStringArray = array of string;

  TForm1 = class(TForm)
    IdTCPClient1: TIdTCPClient;
    MainMenu1: TMainMenu;
    Zobrazit1: TMenuItem;
    Speciln1: TMenuItem;
    Pipojit1: TMenuItem;
    Engine1: TMenuItem;
    Memo1: TMemo;
    Pkazovdka1: TMenuItem;
    Label1: TLabel;
    procedure Pipojit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IdTCPClient1Work(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Engine1Click(Sender: TObject);
    procedure Pkazovdka1Click(Sender: TObject);
  private
    { Private declarations }
    EnginePracuje, EngineStoji, EngineHotovo: boolean;
  public
    { Public declarations }
    vytahu, aktvytah: integer;
    procedure MujEngine;
    function PosliACekejNaOdpoved(prikaz: string): string;
    procedure ZavriVytah(v: string; cekat: boolean);
    procedure OtevriVytah(v: string);
    procedure ZavriVsechnyVytahy;
    procedure PosliVytahDoPoschodi(p, v: string; up: boolean);
  end;

var
  Form1: TForm1;
  PrikazPrikazoveRadky: string;

implementation

{$R *.dfm}

function ParsePrikaz(prikaz: string): TStringArray;
var
  parametru, i, j: integer;


begin
  SetLength(Result, 4);
  prikaz := prikaz + ' ';
  parametru := 0;
  i := 1;
  while true do
  begin
    j := PosEx(' ', prikaz, i);
    if j = 0 then break;

    Dec(j);

    Inc(parametru);
    if parametru > Length(Result) then SetLength(Result, 2 * Length(Result));
    Result[parametru - 1] := Copy(prikaz, i, j - i + 1);

    i := j + 2;
  end;
  
  SetLength(Result, parametru);

end;



procedure TForm1.Pipojit1Click(Sender: TObject);
var
  kampripojit: string;
  i, dvojtecka: integer;
  chyba: boolean;
  sHost: string;
  iPort: integer;

begin
  if not IdTCPClient1.Connected then
  begin
    kampripojit := Format('%s:%d', [IdTCPClient1.Host, IdTCPClient1.Port]);
    if InputQuery('Pipojit', 'Zadejte ve formtu adresa_hostitele:port', kampripojit) then
    begin
      //rozparseruje retezec
      chyba := false;
      dvojtecka := 0;
      for i := Length(kampripojit) downto 1 do
        if kampripojit[i] = ':' then
        begin
          dvojtecka := i;
          break;
        end;

      if dvojtecka = 0 then chyba := true;

      sHost := Copy(kampripojit, 1, dvojtecka - 1);
      if not TryStrToInt(Copy(kampripojit, dvojtecka + 1, Length(kampripojit)), iPort) then chyba := true;

      if not chyba then
      begin
        IdTCPClient1.Host := sHost;
        IdTCPClient1.Port := iPort;
        try
          aktvytah := 0;
          IdTCPClient1.Connect();
          Memo1.Lines.Add(Format('Pipojeno k %s:%d', [IdTCPClient1.Host, IdTCPClient1.Port]));
          EnginePracuje := true;
          EngineHotovo := false;
        finally
          //on E: Exception do
          //  ShowMessageFmt('Chyba pi pokusu o pipojen: ', [E.Message]);
        end;
        //ShowMessageFmt('"%s"; "%d"', [IdTCPClient1.Host, IdTCPClient1.Port]);
      end
      else
      begin
        ShowMessage('Chybn formt, zkuste to znovu.');
      end;
    end;
  end
  else
  begin
    EnginePracuje := false;
    IdTCPClient1.Disconnect;
    Memo1.Lines.Add('Odpojeno');
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IdTCPClient1.Connected then IdTCPClient1.Disconnect;
end;

procedure TForm1.IdTCPClient1Work(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
begin
  if AWorkMode = wmRead then
    Sender := Sender;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  EnginePracuje := false;
  EngineStoji := false;
end;

procedure TForm1.Engine1Click(Sender: TObject);
begin
  Engine1.Checked := not Engine1.Checked;
  EnginePracuje := Engine1.Checked;

  if EnginePracuje then MujEngine;

end;

procedure TForm1.MujEngine;
var
  prikaz: string;
  param: TStringArray;
  jetkam: array of integer;

begin
  EngineHotovo := false;

  // hlavni smycka pro spravu udalosti, chtel jsem nejdriv pouzit vlakno, ale
  // kdyz jsem se o to pokousel dosel sem k zaveru, ze by se to docela tezce
  // synchronizovalo
  jetkam := nil;

  prikaz := PosliACekejNaOdpoved('shafts');
  if prikaz <> '' then
  begin
    param := ParsePrikaz(prikaz);
    if not TryStrToInt(param[1], vytahu) then vytahu := 0;
    if param[0] <> '' then;
    Memo1.Lines.Add(prikaz);
    ZavriVsechnyVytahy;
  end;

  repeat
    Application.ProcessMessages;
    Sleep(1);
    if not EnginePracuje then break;
    if EngineStoji then
    begin
      while EngineStoji do if Application.Terminated then break;
      if Application.Terminated then break;
    end;

    if not IdTCPClient1.Connected then break;

    prikaz := IdTCPClient1.ReadLn(LineTerm, TimeOut);
    if prikaz <> '' then Memo1.Lines.Add(prikaz);

    param := ParsePrikaz(prikaz);
    if Length(param) = 3 then
    begin
      if param[0] = 'cabinbutton' then
      begin
        IdTCPClient1.WriteLn(Format('indion %s %s', [param[1], param[2]]));
        PosliVytahDoPoschodi(param[2], param[1], true);
      end;
    end;
    if Length(param) = 2 then
    begin
      if param[0]= 'levelbuttonup' then
      begin
        IdTCPClient1.WriteLn(Format('indiupon  %s', [param[1]]));
        PosliVytahDoPoschodi(param[1], IntToStr(aktvytah), true);
        Inc(aktvytah); if aktvytah > vytahu -1 then aktvytah := 0;
      end;
      if param[0]= 'levelbuttondn' then
      begin
        IdTCPClient1.WriteLn(Format('indidnon  %s', [param[1]]));
        PosliVytahDoPoschodi(param[1], IntToStr(aktvytah), false);
        Inc(aktvytah); if aktvytah > vytahu -1 then aktvytah := 0;
      end;
      if param[0] = 'shafts' then
      begin
        if not TryStrToInt(param[1], vytahu) then vytahu := 0;
        ZavriVsechnyVytahy;
      end;
    end;
    Label1.Caption := IntToStr(vytahu) + ' vytahu';
  until Application.Terminated;
  EnginePracuje := false;
  Engine1.Checked := false;

  EngineHotovo := true;
end;

function TForm1.PosliACekejNaOdpoved(prikaz: string): string;
var
  s: string;
begin
  IdTCPClient1.WriteLn(prikaz);
  s := '';
  while True do
  begin
    s := IdTCPClient1.ReadLn(LineTerm, TimeOut);
    if s <> '' then break;
    Sleep(10);
    Application.ProcessMessages;
    if Application.Terminated then break;
  end;
  Result := s;
end;

procedure TForm1.Pkazovdka1Click(Sender: TObject);
var
  prikaz: string;
begin
  prikaz := PrikazPrikazoveRadky;
  if InputQuery('Pkazov dka', 'Zadejte pkaz', prikaz) then
  begin
    IdTCPClient1.WriteLn(prikaz);
    PrikazPrikazoveRadky := prikaz;
  end;
end;

procedure TForm1.ZavriVytah(v: string; cekat: boolean);
var
  s: string;
  param: TStringArray;
  time: cardinal;
begin
  if cekat then
  while true do
  begin
    s := IdTCPClient1.ReadLn(LineTerm, TimeOut);

    if s <> '' then Memo1.Lines.Add(s);
    Application.ProcessMessages;
    if s <> '' then
    begin
      param := ParsePrikaz(s);
      if param[0] = 'cabinbutton' then break;
      if param[0] = 'opened' then break;
    end;
  end;

  IdTCPClient1.WriteLn('close ' + v);
  s := '';
  time := gettickcount;
  while True do
  begin
    s := IdTCPClient1.ReadLn(LineTerm, TimeOut);
    if s <> '' then Memo1.Lines.Add(s);
    Application.ProcessMessages;
    if s = 'closed ' + v then break;
    Sleep(10);
    if Application.Terminated then break;

    if gettickcount - time > 1000 then
    begin
      IdTCPClient1.WriteLn('close ' + v);
      time := gettickcount;
    end;
  end;
end;

procedure TForm1.ZavriVsechnyVytahy;
var
  i: integer;
begin
  for i := 0 to vytahu - 1 do ZavriVytah(IntToStr(i), false);
end;

procedure TForm1.PosliVytahDoPoschodi(p, v: string; up: boolean);
var
  i: integer;

begin
  IdTCPClient1.WriteLn(Format('floor %s %s', [v, p]));
  OtevriVytah(v);
  //IdTCPClient1.WriteLn(Format('open %s', [v]));

  //if up then

  Sleep(000);

  ZavriVytah(v, true);

  IdTCPClient1.WriteLn(Format('indiupoff %s', [p]));
  //else
  IdTCPClient1.WriteLn(Format('indidnoff %s', [p]));

  IdTCPClient1.WriteLn(Format('indioff %s %s', [v, p]));
end;

procedure TForm1.OtevriVytah(v: string);
var
  s: string;
begin
  IdTCPClient1.WriteLn('open ' + v);
  s := '';
  while True do
  begin
    s := IdTCPClient1.ReadLn(LineTerm, TimeOut);
    if s <> '' then Memo1.Lines.Add(s);
    Application.ProcessMessages;
    if s = 'opened ' + v then break;
    Sleep(10);
    if Application.Terminated then break;
  end;
end;

end.
